#!/bin/sh
 
#Write Device Name and Description to joined ZeroTier Networks
 
netIDArr=$(zerotier-cli listnetworks | sed '1d' | awk '{​​​​​​​print $3}​​​​​​​')
 
SAVEIFS=$IFS            # Save current IFS (Internal Field Separator)
IFS=$'\n'               # Change IFS to newline char
netIDArr=($netIDArr)    # split the `netIDArr` string into an array by the same name
IFS=$SAVEIFS            # Restore original IFS
 
echo ${​​​​​​​netIDArr[@]}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​
 
ztInfo=$(zerotier-cli info)
serialNum=$(/usr/sbin/dmidecode -s system-serial-number)
productName=$(/usr/sbin/dmidecode -s system-product-name)
dmidecode
read -ra ztInfoArr <<< "$ztInfo" #put info into array
memID="${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​ztInfoArr[2]}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​"
onlineStatus="${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​ztInfoArr[4]}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​"
 
for (( i=0; i<${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​#netIDArr[@]}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​; i++ )) #iterate through all joined networks and apply Name and Description
do
        curl -X POST https://my.zerotier.com/api/v1/network/${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​netIDArr[$i]}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​/member/$memID -H "Authorization: bearer NPrDHKS8jyxnKHf0IuCSH0RAKxoxDUk7" -d '{​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​"name": "'${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​HOSTNAME}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​'","description": "'"${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​productName}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​"' '"${​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​serialNum}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​"'"}​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​​'
        echo $response
done